<!DOCTYPE html>
<html lang="en">

<head>
    <title>Task 23B.40 Hãy làm lại giao diện Lucky Dice Casino bằng Bootstrap4 từ đầu</title>
    <meta charset='utf-8'>
    <meta name='viewport' content='width=device-width, initial-scale=1'>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <style>
        .picture-cover {
            background-image: url("LuckyDiceImages/cover.jpg");
            min-height: 100px;
            margin: 5px;
        }
    </style>
</head>

<body>
    <div class="container-fluid picture-cover"></div>
    <div class="container">
        <div class="row">
            <div class="col-5">
                <div class="row form-group">
                    <h4>Nhập thông tin của bạn</h4>
                </div>
                <div class="row form-group">
                    <div class="col-4 ">
                        <label>Username</label>
                    </div>
                    <div class="col-8 ">
                        <input id="inp-username" class="form-control" type="text" placeholder="nhập username">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-4 ">
                        <label>Firstname</label>
                    </div>
                    <div class="col-8 ">
                        <input id="inp-firstname" class="form-control" type="text" placeholder="nhập firstname">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-4 ">
                        <label>Lastname</label>
                    </div>
                    <div class="col-8">
                        <input id="inp-lastname" class="form-control" type="text" placeholder="nhập lastname">
                    </div>
                </div>
            </div>
            <div class="col-4">
                <div class="row form-group text-center ">
                    <div class="col-12">
                        <input id="btn-dice" class="btn btn-warning button-width w-35" value="Ném" type="button"
                            onclick="onBtnNemClick()">
                    </div>
                </div>
                <div class="row form-group  text-center">
                    <div class="col-12 ">
                        <img src="LuckyDiceImages/dice.png" class="img-thumbnail" id="img-dice">
                    </div>
                </div>
                <div class="row form-group text-center">
                    <div class="col-12 ">
                        <p id="p-dice">Chúc mừng</p>
                    </div>
                </div>
            </div>
            <div class="col-3">
                <div class="row form-group text-center">
                    <div class="col-12 ">
                        <p>Voucher:</p>
                        <p id="p-voucher-id">No ID</p>
                        <p id="p-voucher-percent">0%</p>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12 ">
                        <img id="img-present" class="img-thumbnail" src="LuckyDiceImages/motobike.jpg" style="size: 50px;">
                    </div>
                </div>
            </div>
        </div>
        <div class="row form-group text-center">
            <div class="col-12">
                <button id="btn-dice-history" class="btn btn-info button-width w-25"
                    onclick="onBtnDiceHistoryClick()">Dice History</button>
                <button id="btn-voucher-history" class="btn btn-success button-width w-25">Voucher History</button>
                <button id="btn-present-history" class="btn btn-success button-width w-25">Present History</button>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-12 ">
                <table id="history-placeholder-table" class="table table-bordered table-striped table-hover">
                    <thead>
                    </thead>
                    <tbody>
                        <!-- tbody chưa có dòng dữ liệu nào-->
                    </tbody>
                </table>
                </table>
            </div>
        </div>
    </div>
</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice/";
    const gUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";
    const gEND_ROW_TABLE = -1;
    const gUSER_LUOT = 0;
    const gUSER_DICE = 1;
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onBtnNemClick() {
        var vObjectUser = {
            username: "",
            firstname: "",
            lastname: ""
        };
        // b1: thu thập dữ liệu
        thuThapDuLieuUser(vObjectUser);
        // b2: validate
        var vKetQua = kiemTraDuLieuUser(vObjectUser);
        if (vKetQua) {
            var vXmlHttpDice = new XMLHttpRequest();
            // b3: gọi api
            goiApiNewDice(vXmlHttpDice, vObjectUser);
            vXmlHttpDice.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {  //nếu trạng thái của response ready và ok
                    // b4: Hiển thị dữ liệu
                    hienThiDuLieuDice(vXmlHttpDice);
                }
            }
        }
    }
    function onBtnDiceHistoryClick() {
        var vObjectUser = {
            username: "",
        };
        // b1: thu thập dữ liệu
        thuThapDuLieuUserName(vObjectUser);
        // b2: kiểm tra dữ liệu
        var vKetQua = kiemTraDuLieuUsername(vObjectUser);
        if (vKetQua) {
            var vXmlHttpDiceHistory = new XMLHttpRequest();
            // b3: gọi Api
            goiApiDiceHistory(vXmlHttpDiceHistory, vObjectUser);
            vXmlHttpDiceHistory.onreadystatechange =
                function () {
                    if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                        hienThiDiceHistory(vXmlHttpDiceHistory);
                    }
                }
        }
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm thu thập dữ liệu user
    function thuThapDuLieuUser(paramObjectUser) {
        var vUserNameTest = document.getElementById("inp-username");
        var vFirstNameTest = document.getElementById("inp-firstname");
        var vLastNameTest = document.getElementById("inp-lastname");

        paramObjectUser.username = vUserNameTest.value.trim();
        paramObjectUser.firstname = vFirstNameTest.value.trim();
        paramObjectUser.lastname = vLastNameTest.value.trim();
    }
    // Hàm kiểm tra dữ liệu User 
    function kiemTraDuLieuUser(paramObjectUser) {
        if (paramObjectUser.username == "") {
            alert("Bạn chưa nhập username");
            return false;
        }
        if (paramObjectUser.firstname == "") {
            alert("Bạn chưa nhập firstname");
            return false;
        }
        if (paramObjectUser.lastname == "") {
            alert("Bạn chưa nhập lastname");
            return false;
        }
        return true;
    }
    // Hàm gọi Api
    function goiApiNewDice(paramXmlHttp, paramObjectUser) {
        paramXmlHttp.open("POST", gBASE_URL + "/dice", true);
        paramXmlHttp.setRequestHeader("Content-Type", gUTF8_TEXT_APPLICATION_HEADER);
        paramXmlHttp.send(JSON.stringify(paramObjectUser));  //chuyển Json object sang string
    }
    // Hàm hiển thị dữ liệu 
    function hienThiDuLieuDice(paramXmlHttp) {
        console.log(paramXmlHttp.responseText);
        var vResponse = JSON.parse(paramXmlHttp.responseText);
        var vDiceReady = vResponse.dice;
        changeDice(vDiceReady);
        changeNottification(vDiceReady);
        changeVoucher(vResponse);
        changeGift(vResponse);
    }
    // Hàm hiển thị dice
    function changeDice(paramDice) {
        var vImgDice = document.getElementById("img-dice");
        switch (paramDice) {
            case 1:
                vImgDice.src = "LuckyDiceImages/1.png";
                break;
            case 2:
                vImgDice.src = "LuckyDiceImages/2.png";
                break;
            case 3:
                vImgDice.src = "LuckyDiceImages/3.png";
                break;
            case 4:
                vImgDice.src = "LuckyDiceImages/4.png";
                break;
            case 5:
                vImgDice.src = "LuckyDiceImages/5.png";
                break;
            default:
                vImgDice.src = "LuckyDiceImages/6.png";
        }
    }
    // Hàm hiển thị lời nhắn
    function changeNottification(paramDice) {
        var vNotification = document.getElementById("p-dice");
        if (paramDice < 4) {
            vNotification.innerHTML = ("Chúc bạn may mắn lần sau !!!");
        }
        else {
            vNotification.innerHTML = ("Chúc mừng bạn hãy chơi tiếp lần nữa !!!");
        }
    }
    // Hàm hiển thị voucher
    function changeVoucher(paramVoucher) {
        var vVoucherId = document.getElementById("p-voucher-id");
        var vVoucherPersent = document.getElementById("p-voucher-percent");
        if (paramVoucher.voucher != null) {
            vVoucherId.innerHTML = paramVoucher.voucher.maVoucher;
            vVoucherPersent.innerHTML = paramVoucher.voucher.phanTramGiamGia + "%";
        }
        else {
            vVoucherId.innerHTML = "";
            vVoucherPersent.innerHTML = "";
        }
    }
    // Hàm hiển thị phần thưởng
    function changeGift(paramPrize) {
        var vImgPresent = document.getElementById("img-present");
        var vTenPhanThuong = paramPrize.prize;
        switch (vTenPhanThuong) {
            case "Mũ":
                vImgPresent.src = "LuckyDiceImages/hat.jpg";
                break;
            case "Áo mưa":
                vImgPresent.src = "LuckyDiceImages/t-shirt.jpg";
                break;
            case "Xe máy":
                vImgPresent.src = "LuckyDiceImages/motobike.jpg";
                break;
            default:
                vImgPresent.src = "LuckyDiceImages/no-present.jpg";
        }
    }

    // hàm thu thập dữ liệu
    function thuThapDuLieuUserName(paramUser) {
        var vUserName = document.getElementById("inp-username");
        paramUser.username = vUserName.value.trim();
    }
    // hàm kiểm tra dữ liệu
    function kiemTraDuLieuUsername(paramUser) {
        if (paramUser.username == "") {
            alert("Bạn cần nhập username");
            return false;
        }
        return true;
    }
    // hàm gọi api dice history
    function goiApiDiceHistory(paramXmlHttpDiceHistory, paramUser) {
        paramXmlHttpDiceHistory.open("GET", gBASE_URL + "/dice-history?username=" + paramUser.username, true);
        paramXmlHttpDiceHistory.send();
    }
    // hàm hiển thi dice history
    function hienThiDiceHistory(paramXmlHttpDiceHistory) {
        var vResponse = JSON.parse(paramXmlHttpDiceHistory.responseText);
        console.log(paramXmlHttpDiceHistory.responseText);
        var vTable = document.getElementById("history-placeholder-table");
        var vTableHead = document.getElementsByTagName("thead")[0];
        vTableHead.innerHTML = "";
        var vNewRowTD = vTableHead.insertRow(gEND_ROW_TABLE);
        var vNewCellGameTD = vNewRowTD.insertCell(gUSER_LUOT);
        var vNewCellDiceTD = vNewRowTD.insertCell(gUSER_DICE);
        vNewCellGameTD.innerHTML = "Game";
        vNewCellDiceTD.innerHTML = "Dice";
        var vTableBody = document.getElementsByTagName("tbody")[0];
        vTableBody.innerHTML = "";
        for (var bI = 0; bI < vResponse.dices.length; bI++) {
            var vNewRow = vTableBody.insertRow(gEND_ROW_TABLE);
            var vNewCellGame = vNewRow.insertCell(gUSER_LUOT);
            var vNewCellDice = vNewRow.insertCell(gUSER_DICE);
            vNewCellGame.innerHTML = bI + 1;
            vNewCellDice.innerHTML = vResponse.dices[bI];
        }
    }
</script>

</html>